﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SalesVizu
{
    public class BigGraph
    {
        public enum Type { ValueMSP, Sales, SalesAndUnsoldTrials }
        public static Type type = 
            Type.ValueMSP;
            //Type.Sales;
            //Type.SalesAndUnsoldTrials;
        const int leftColumn = 100;
        static RenderTarget2D renderBox, renderGraph;
        static Rectangle DestRect, InsideRect;
        public static int Bottom { get { return DestRect.Bottom; } }
        public static int Left { get { return DestRect.Left; } }
        public static int Width { get { return DestRect.Width; } }

        public static void Load()
        {
            DestRect = new Rectangle(0, 0,
                Games.Left,
                Game1.ChartByCountry.Top - 75 - 40);
            renderBox = LibMaximinus.NewRenderTarget(DestRect.Width, DestRect.Height);

            const int gap = 5; 
            InsideRect = DestRect;
            InsideRect.X += leftColumn;
            InsideRect.Y += gap;
            InsideRect.Width -= leftColumn + gap;
            InsideRect.Height -= 2 * gap;
        }

        public static int DrawOnFrame = -1;

        public static void PreDraw()
        {
            if (LoadSales.Rebuilding == false && Totals.DataChangeFrame >= 0 && DrawOnFrame < Totals.DataChangeFrame)
            {
                DrawOnFrame = MaximinusGame.CurrentFrame;

                renderGraph = LibMaximinus.NewRenderTarget(Totals.AllDatesForTimeScale.Count, InsideRect.Height);

                MaximinusGame.Instance.GraphicsDevice.SetRenderTarget(renderGraph);
                MaximinusGame.Instance.GraphicsDevice.Clear(Color.Transparent);
                MaximinusGame.Instance.SpriteBatch.Begin();
                for(int dateIndex = 0; dateIndex<Totals.AllDatesForTimeScale.Count; dateIndex++)
                {
                    int total = 0;
                    for(int g=0; g<Data.Games.Length; g++)
                    {
                        Color col = Colors.GameColor(g);
                        if (type == Type.SalesAndUnsoldTrials)
                        {
                            col.A = 128;
                        }


                        int value = Totals.AllDatesForTimeScale[dateIndex].SalesTrialsValuesByGame[(int)type, g];
                        MaximinusGame.Instance.SpriteBatch.Draw(MaximinusGame.Instance.BlankTex,
                            new Rectangle(dateIndex, (int)(renderGraph.Height * (1 - (float)(total + value) / Totals.MaxCount[(int)type])), 1,
                                (int)(renderGraph.Height * (float)value / Totals.MaxCount[(int)type])),
                            col);
                        int realMax = value;

                        if (type == Type.SalesAndUnsoldTrials)
                        {
                            int sales = Totals.AllDatesForTimeScale[dateIndex].SalesTrialsValuesByGame[(int)Type.Sales, g];
                            col.A = 255;
                            MaximinusGame.Instance.SpriteBatch.Draw(MaximinusGame.Instance.BlankTex,
                                new Rectangle(dateIndex, (int)(renderGraph.Height * (1 - (float)(total + sales) / Totals.MaxCount[(int)type])), 1,
                                    (int)(renderGraph.Height * (float)sales / Totals.MaxCount[(int)type])),
                                col);
                            realMax = Math.Max(value, sales);
                            value = sales;
                        }


                        total += realMax;// value;
                    }
                }
                MaximinusGame.Instance.SpriteBatch.End();



                MaximinusGame.Instance.GraphicsDevice.SetRenderTarget(renderBox);
                MaximinusGame.Instance.GraphicsDevice.Clear(Color.Transparent);
                MaximinusGame.Instance.SpriteBatch.Begin(SpriteSortMode.Immediate, BlendState.NonPremultiplied, SamplerState.PointClamp, DepthStencilState.None, RasterizerState.CullNone);
                MaximinusGame.Instance.SpriteBatch.Draw(MaximinusGame.Instance.BlankTex, InsideRect, Color.White);
                MaximinusGame.Instance.SpriteBatch.Draw(renderGraph, InsideRect, Color.White);
                DrawScaleY();
                MaximinusGame.Instance.SpriteBatch.End();
            }
        }

        static void DrawScaleY()
        {
            String label = "";
            switch (type)
            {
                case Type.Sales:
                    label = "Sales\nUnits";
                    break;
                case Type.SalesAndUnsoldTrials:
                    label = "Sales &\nTrials";
                    break;
                case Type.ValueMSP:
                    label = "Value " + Currency.Symbol;
                    break;
            }
            MaximinusGame.DrawStringOutlined(
                label, MaximinusGame.Instance.Font,
                //new Vector2(leftColumn / 2, leftColumn / 4),
                new Vector2(leftColumn * 3 / 2, leftColumn / 3), 
                Color.White, 1, 1);

            int max = Totals.MaxCount[(int)type];
            if (type == Type.ValueMSP)
            {
                max = (int)(max * Currency.MSP2Currency); // Totals.MSP2Dollars);
            }


            List<int> controlValues = new List<int>();

            // V1
            //// find biggest power of 10 smaller than total
            //int scaleMax = 10;
            //while (scaleMax * 10 < max) { scaleMax *= 10; }
            //// find biggest integer smaller than 10, that when multiplied by scaleMax is smaller than max
            //int scaleMax2 = scaleMax;
            //while (scaleMax + scaleMax2 < max) { scaleMax += scaleMax2; }
            //if (scaleMax == 100)
            //{
            //    scaleMax = (max / 10) * 10;
            //}
            //// now use scaleMax


            // V2
            //int powerOf10 = 10;
            ////while (powerOf10 * 10 < max) { powerOf10 *= 10; }
            //int scaleMax = (max / powerOf10) * powerOf10;
            //int nbControls = 11;
            //for (int i = 1; i < nbControls; i++) { controlValues.Add(scaleMax * i / nbControls); }


            // V3
            //int maxPowerOf10LowerThanMax = 1;
            //while (maxPowerOf10LowerThanMax * 10 < max)
            //{
            //    maxPowerOf10LowerThanMax *= 10;
            //}
            //int maxMultipleOfPowerLowerThanMax = max / maxPowerOf10LowerThanMax;

            ////maxMultipleOfPowerLowerThanMax *= maxPowerOf10LowerThanMax;
            //for (int i = 1; i <= maxMultipleOfPowerLowerThanMax; i++)
            //{
            //    //controlValues.Add(maxMultipleOfPowerLowerThanMax);
            //    controlValues.Add(i * maxPowerOf10LowerThanMax);
            //}

            // V4
            controlValues.Add(max);
            int maxPowerOf10LowerThanMax = 1;
            while (maxPowerOf10LowerThanMax * 10 < max)
            {
                maxPowerOf10LowerThanMax *= 10;
            }
            int maxMultipleOfPowerLowerThanMax = (max / maxPowerOf10LowerThanMax) * maxPowerOf10LowerThanMax;
            if ((float)max / maxMultipleOfPowerLowerThanMax > 1.33f)
            {
                controlValues.Add(maxMultipleOfPowerLowerThanMax * 1 / 4);
                controlValues.Add(maxMultipleOfPowerLowerThanMax * 2 / 4);
                controlValues.Add(maxMultipleOfPowerLowerThanMax * 3 / 4);
                controlValues.Add(maxMultipleOfPowerLowerThanMax * 4 / 4);
                controlValues.Add(maxMultipleOfPowerLowerThanMax * 5 / 4);
            }
            else
            {
                if ((float)max / maxMultipleOfPowerLowerThanMax < 1.1f == false)
                {
                    controlValues.Add(maxMultipleOfPowerLowerThanMax);
                }
                if (maxMultipleOfPowerLowerThanMax / maxPowerOf10LowerThanMax == 1)
                {
                    maxPowerOf10LowerThanMax /= 10;
                }

                for (int i = (maxMultipleOfPowerLowerThanMax / maxPowerOf10LowerThanMax) - 1; i > 0; i--)
                {
                    controlValues.Add(i * maxPowerOf10LowerThanMax);
                }
            }

            foreach (int controlValue in controlValues)
            {
                int height = InsideRect.Bottom - (int)(InsideRect.Height * (float)controlValue / max);
                MaximinusGame.DrawStringOutlined(
                    //Xlabel,
                    controlValue.ToString("0"),
                    MaximinusGame.Instance.Font,
                    new Vector2(leftColumn / 2, height + 5), Color.White, 1, 1);
                MaximinusGame.Instance.SpriteBatch.Draw(MaximinusGame.Instance.BlankTex,
                    new Rectangle(
                        InsideRect.Left,
                        height,
                        InsideRect.Width,
                        1),
                    new Color(50, 50, 50, 128));
            }
        }

        public static void Draw()
        {
            MaximinusGame.Instance.SpriteBatch.Draw(renderBox, DestRect, Color.White);
        }
    }
}
