﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SalesVizu
{
    public class ByCountry
    {
        static readonly String[] Countries =
        {
            "United States",
            "United Kingdom",
            "Canada",
            "France",
            "Germany",
            "Italy",
            "Spain",
            "Sweden",
            "Japan",
            "Singapore",
            "Netherlands",
            "Mexico",
            "Ireland",
            "Unknown"
        };
        public static int NbCountries { get { return Countries.Length; } }
        public static int CountryIndex(String name)
        {
            for (int c = 0; c < Countries.Length; c++)
            {
                if (Countries[c] == name) { return c; }
                if (name == "" && Countries[c] == "Unknown") { return c; }
            }
            throw new Exception();
        }
        //static Color CountryColor(int countryIndex)
        //{
        //    switch(countryIndex)
        //    {
        //        case 0: return Color.Red;
        //        case 1: return Color.Blue;
        //        case 2: return Color.Gold;
        //        case 3: return Color.Green;
        //        case 4: return Color.Orange;
        //        case 5: return Color.Gray;
        //        case 6: return Color.Pink;
        //        case 7: return Color.White;
        //        case 8: return Color.Purple;
        //        case 9: return Color.Fuchsia;
        //        case 10: return Color.Black;
        //    }
        //    throw new Exception();
        //}
        public static String LabelOf(int countryIndex)
        {
            String ret = "";
            switch (countryIndex)
            {
                case 0: 
                    ret = "USA";
                    break;
                case 1: 
                    ret = "UK";
                    break;
                default: 
                    ret = Countries[countryIndex];
                    break;
            }
            return ret + " " + (Totals.ValueMSPbyCountry[countryIndex] * 100).ToString("0.0") + "%";
        }
        public static Color ColorOf(float ratio)
        {
            float currentR = Totals.ValueMSPbyCountry[0];
            for (int currentI = 0; currentI < NbCountries; currentI++)
            {
                if (ratio < currentR)
                {
                    return Colors.GameColor(currentI);// CountryColor(currentI);
                }
                else
                {
                    if (currentI + 1 >= Totals.ValueMSPbyCountry.Count)
                    {
                        return Color.Transparent;
                    }
                    currentR += Totals.ValueMSPbyCountry[currentI + 1];
                }
            }
            throw new Exception();
        }
    }
}
