﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SalesVizu
{
    public class ConvRates
    {
        static RenderTarget2D render;
        static Rectangle DestRect;

        public static void Load()
        {
            int top = Game1.ChartByCountry.Top;
            DestRect = new Rectangle(
                Game1.ChartByCountry.Right,
                top,
                Game1.RenderMain.Width - Game1.ChartByCountry.Right,
                Game1.RenderMain.Height - top);
            render = LibMaximinus.NewRenderTarget(DestRect.Width, DestRect.Height);
        }

        public static int DrawOnFrame = -1;

        public static void PreDraw()
        {

            if (LoadSales.Rebuilding == false && Totals.DataChangeFrame >= 0 && DrawOnFrame < Totals.DataChangeFrame)
            {
                DrawOnFrame = MaximinusGame.CurrentFrame;

                MaximinusGame.Instance.GraphicsDevice.SetRenderTarget(render);
                MaximinusGame.Instance.GraphicsDevice.Clear(Color.Transparent);
                MaximinusGame.Instance.SpriteBatch.Begin();

                float maxConvRate = Totals.ConvRateByGame.Max();
                bool noRecordForAnyGame = maxConvRate <= 0;
                if (noRecordForAnyGame) { maxConvRate = 1f; }

                int width = DestRect.Width / 2 / Data.Games.Length;
                int heightGap = DestRect.Height / 10;

                for (int g = 0; g < Data.Games.Length; g++)
                {
                    if (Games.Selected[g])
                    {
                        int X = (int)(DestRect.Width * (g + .5f) / (Data.Games.Length + .75f));

                        MaximinusGame.DrawStringOutlined(
                            (g + 1).ToString("00"),
                            MaximinusGame.Instance.Font,
                            new Vector2(
                                X + width / 2,
                                DestRect.Height - heightGap * .5f),
                            Colors.GameColor(g), 1, 1);

                        if (Totals.ConvRateByGame[g] > 0)
                        {
                            Rectangle dest = new Rectangle(X, 0, width, 0);
                            dest.Height = (int)((DestRect.Height - 1 * heightGap) * Totals.ConvRateByGame[g] / maxConvRate);
                            dest.Y = DestRect.Height - heightGap - dest.Height;

                            MaximinusGame.Instance.SpriteBatch.Draw(MaximinusGame.Instance.BlankTex,
                                dest,
                                Colors.GameColor(g));
                            MaximinusGame.OutlineRectangle(dest, Color.Black, 1);

                            MaximinusGame.DrawStringOutlined(
                                " " + (Totals.ConvRateByGame[g] * 100).ToString("0.0") + "%",
                                MaximinusGame.Instance.Font,
                                new Vector2(dest.Center.X, dest.Top + 13),
                                Colors.GameColor(g), .9f, 1);
                        }
                    }
                }
                MaximinusGame.Instance.SpriteBatch.End();
            }
        }
        public static void Draw()
        {
            MaximinusGame.DrawStringOutlined(
                "Conversion Rates",
                MaximinusGame.Instance.Font,
                new Vector2(DestRect.Center.X, DestRect.Top - 20),
                Color.White, 1, 1);
            MaximinusGame.Instance.SpriteBatch.Draw(render, DestRect, Color.White);                
        }
    }
}
