﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using System.Web;
using System.IO;

namespace SalesVizu
{
    public class Currency
    {
        
        public enum Type { Dollars, Euros, Pounds };
        public static Type type = Type.Dollars;

        public static String Symbol
        {
            get
            {
                switch (type)
                {
                    case Type.Dollars: return "$";
                    case Type.Euros: return "€";
                    case Type.Pounds: return "£";
                }
                throw new NotImplementedException();
            }
        }
        public static float MSP2Currency
        {
            get
            {
                switch(type)
                {
                    case Type.Dollars: return MSP2Dollars;
                    case Type.Euros: return MSP2Dollars * DollarsToEUR;
                    case Type.Pounds: return MSP2Dollars * DollarsToGBP;
                }
                throw new NotImplementedException();
            }
        }

        const float MSP2Dollars = 62908.48f / 7427200f;
        public static float DollarsToEUR = 0;
        public static float DollarsToGBP = 0;

        public static void Draw()
        {
            if (type != Type.Dollars)
            {
                float rate = type == Type.Euros ? DollarsToEUR : type == Type.Pounds ? DollarsToGBP : 0;
                MaximinusGame.DrawStringOutlinedNotCentered(
                    "1 $ = " + rate.ToString("0.0000") + " " + Symbol,                    
                    new Vector2(35, Buttons.ButtonDollarBottom + 05),
                    Color.White, 1, 1);
            }
        }

        public static void FetchRates()
        {
            try
            {
                String
                    tmp = System.Environment.GetEnvironmentVariable("TMP"),
                    fileEUR = tmp + "\\rateUSDEUR.html",
                    urlEUR = "http://finance.yahoo.com/q/bc?s=USDEUR=X",
                    fileGBP = tmp + "\\rateUSDGBP.html",
                    urlGBP = "http://finance.yahoo.com/q/bc?s=USDGBP=X";
                DollarsToEUR = FetchRate(urlEUR, fileEUR, "yfs_l10_usdeur");
                DollarsToGBP = FetchRate(urlGBP, fileGBP, "yfs_l10_usdgbp=x");
            }
            catch (Exception) { }
        }
        static float FetchRate(String url, String file, String token)
        {
            try
            {
//#warning TODO catch output directly rather than write to file and read
                MaximinusGame.LaunchSystemCommand(
                    Settings.WgetBinary,
                    url + " -O " + file,
                    true, true);
                StreamReader s = new StreamReader(file);
                while (!s.EndOfStream)
                {
                    String line = s.ReadLine();
                    if (line.Contains(token))
                    {
                        int start = line.IndexOf(token);
                        line = line.Remove(0, start);
                        line = line.Split('>')[1];
                        line = line.Split('<')[0];
                        line = line.Replace('.', ',');
                        return float.Parse(line);
                            //, System.Globalization.NumberStyles.Any);
                            //.AllowDecimalPoint);
                    }
                }
                s.Close();
            }
            catch (Exception) { }
            return 0;
        }
    }
}
