﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace SalesVizu
{
    public class TimeFrame
    {
        public struct Date
        {
            public int Year, Month, Day;
            public int[,] SalesTrialsValuesByGame;

            public int Max(int type)
            {
                int ret = 0;
                for (int g = 0; g < Data.Games.Length; g++)
                {
                    ret += SalesTrialsValuesByGame[type, g];
                }
                return ret;
            }

            public bool IsEarlierThan(Date d)
            {
                return 
                    this.Year < d.Year
                    || (this.Year == d.Year && this.Month < d.Month)
                    || (this.Year == d.Year && this.Month == d.Month && this.Day < d.Day);
            }

            public override bool Equals(object obj)
            {
                return
                    Year == ((Date)obj).Year
                    && Month == ((Date)obj).Month
                    && Day == ((Date)obj).Day;
            }
            public override int GetHashCode() { throw new NotImplementedException(); }            
        }
    }
}
